package org.agt.module.license.service.license;

import jakarta.servlet.http.HttpServletResponse;
import jakarta.validation.Valid;
import org.agt.framework.common.pojo.PageResult;
import org.agt.module.license.controller.admin.license.vo.ImportRespVO;
import org.agt.module.license.controller.admin.license.vo.LicenseCodeImportExcelVO;
import org.agt.module.license.controller.admin.license.vo.LicenseDetailVO;
import org.agt.module.license.controller.admin.license.vo.LicenseImportExcelVO;
import org.agt.module.license.controller.admin.license.vo.LicensePageReqVO;
import org.agt.module.license.controller.admin.license.vo.LicensePageRespVO;
import org.agt.module.license.controller.admin.license.vo.LicenseRespVO;
import org.agt.module.license.controller.admin.license.vo.LicenseSaveReqVO;
import org.agt.module.license.dal.dataobject.license.LicenseDetailDO;

import java.util.List;

/**
 * License Service 接口
 *
 * @author 管理员
 */
public interface LicenseService {

    /**
     * 创建License
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createLicense(@Valid LicenseSaveReqVO createReqVO, boolean isReapply);

    /**
     * 更新License
     *
     * @param updateReqVO 更新信息
     */
    void updateLicense(@Valid LicenseSaveReqVO updateReqVO);

    /**
     * 申请License
     *
     * @param updateReqVO 更新信息
     */
    void applyLicense(@Valid LicenseSaveReqVO updateReqVO, List<LicenseDetailDO> licenseDetails);

    /**
     * 重新申请License
     *
     * @param updateReqVO 更新信息
     */
    void reapplyLicense(@Valid LicenseSaveReqVO updateReqVO);


    /**
     * 生成License
     *
     * @param id license ID
     * @return 文件路径
     */
    String generate(Long id);

    /**
     * 删除License
     *
     * @param id 编号
     */
    void deleteLicense(Long id);

    /**
     * 获得License
     *
     * @param id 编号
     * @return License
     */
    LicenseRespVO getLicense(Long id);

    /**
     * 获得License分页
     *
     * @param pageReqVO 分页查询
     * @return License分页
     */
    PageResult<LicensePageRespVO> getLicensePage(LicensePageReqVO pageReqVO);

    List<LicenseRespVO> getLicenseByExpiryDate();

    /**
     * 校验License的sn是否唯一
     *
     * @param sn sn
     * @param id id
     * @return boolean
     */
    Boolean validateLicenseSnUnique(String sn, Long id);

    List<LicenseRespVO> getLicenseHistory(Long id);

    ImportRespVO importList(List<LicenseImportExcelVO> list, Boolean updateSupport);

    ImportRespVO importCodeList(List<LicenseCodeImportExcelVO> list, Boolean updateSupport);

    void updateDetailById(LicenseDetailVO licenseDetail);

    void download(HttpServletResponse response, Long id);
}